<?

/*************************************************************

Quasimondo's xml2swf class v1.0

Description: xml2swf converts an XML file or XML Data into an swf.
By using GZIP compression this results in much smaller file sizes.

Quick Usage:

Example 1:

$mySWF=new xml2swf("in.xml","out.swf");

will read the XML file "in.xml" and create an compressed swf 
file named "out.swf".


Example 2:

$mySWF=new xml2swf("in.xml");
echo $mySWF->getSWF();

will will read the XML file "in.xml" and return the swf data to the output.


Usage inside Flash:

this.createEmptyMovieClip("xmlLayer")

// after loading the XML can be accssed like this:
// if you do not chage the objectName, the default name
// for the XML object is "xmlData"

test=this.xmlLayer.xmlData.firstChild;
test=this.xmlLayer.xmlData.childNodes;




Copyright 2003 Mario Klingemann 
		
http://www.quasimondo.com
Contact: mario@coma2.com


License:
THE USE OF THIS CODE IS FREE FOR NON-COMMERCIAL PURPOSES.

OF COURSE IF YOU FIND THIS TOOL USEFUL YOU WOULD MAKE ME 
VERY HAPPY BY DONATING A SMALL SUM VIA PAYPAL TO mario@coma2.com

IF YOU WANT TO USE THIS CODE IN A COMMERICAL PRODUCT PLEASE
SEND US$10,- OR 10,- VIA PAYPAL TO: mario@coma2.com.



Disclaimer:
THESE MATERIALS ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, 
OR NON-INFRINGEMENT.

***************************************************************************/



class xml2swf {
	var $xml;
	var $error;
	var $swf;
	var $status;
	var $compressed;
	var $objectName;
	var $ignoreWhite;
	// constructor
	//
	// $xmlFile: optional name for input XML-filename, 
	// if this is set the file will be loaded immediately
	//
	// $swfFile: optional name for output swf-filename, 
	// if this is set (and the xml input file), the swf-file 
	// will be created immediately
	// $swfFile may also be a URL.
	// 
	//
	// $objectName: name of the XML object inside the flash file
	// default is "xmlData"
	//
	// $compressed: defines if the swf file will use compression
	// default is "true"
	function xml2swf($xmlFile=null,$swfFile=null,$objectName="xmlData",$compressed=true){
		$this->status="empty";
		$this->error="";
		$this->ignoreWhite=true;
		$this->compressed=$compressed;
		$this->objectName=$objectName;
		if ($xmlFile!=null){
			if ($this->loadXML($xmlFile)){
				if ($swfFile!=null){
					return $this->saveSWF($swfFile);
				}
			}
			
		}
		
	}
	
	// loadXML
	// 
	// Loads the XML-file $filename into the internal XML storaga
	// returns false if the file does not exists or is unreadable
	// $swfFile may also be a URL.
	//
	function loadXML($filename){
		
		if (strtolower(substr($filename,0,7))=="http://"){
			$content_array = file($filename);
			$xml = implode("", $content_array);
		} else {
		if (!file_exists($filename)){
			$this->error=$filename." does not exist";
			return false;
		}
		if ($fp=fopen($filename,"rb")){
			if (!$xml=fread($fp,filesize($filename))){
				$this->error="Could not read ".$filename;
				$this->status="empty";
				$this->xml="";
				fclose($fp);
				return false;
			}
			fclose($fp);
		} else {
			$this->error="Could not open ".$filename;
			return false;
		}
		}
		return $this->setXML($xml);
		
	}
	
	// setXML
	// 
	// Sets the internal XML storage to the string $xml
	//
	// returns false if $xml is empty
	//
	function setXML($xml){
		if ($xml!=""){
			$this->xml=$xml;
			$this->status="XML";
			$this->error="";
			return $this->convert();
		}else {
			$this->error="XML is empty";
			$this->status="empty";
			return false;
		}
	}
	
	// setObject Name
	//
	// sets the name of the XML object inside the flash file
	//
	function setObjectName($o){
		$this->objectName=$objectName;
	}
	
	// setCompressed
	// 
	//
	// defines if the swf file will use compression
	//	
	function setCompressed($v){
		$this->compressed=$v;
	}
	// setIgnoreWhite
	// 
	// defines if the swf file will ignoreWhitespace
	// defaultuis true
	//	
	function setIgnoreWhite($v){
		$this->ignoreWhite=$v;
	}
	
	// convert
	// 
	// if the internal XML storage contains XML data
	// this method will create the internal swf object
	//
	function convert(){
		if ($this->status!="XML"){
			$this->error="No XML data";
			$this->status="empty";
			return false;
		}
		$pushLength=strlen($this->objectName)+strlen($this->xml)+29;
		if ($pushLength>65535) {
			$this->error="Data block exceeds 64K ($pushLength)";
			return false;
		}
		
		if ($this->compressed)
			$header = pack ("C*",0x43,0x57,0x53,0x06); //CWS, Version 6
		else
			$header = pack ("C*",0x46,0x57,0x53,0x06); //CWS, Version 6
		$basics=  pack ("C*",0x78,0x00,0x05,0x5f,0x00,0x00,0x0f,0xa0,0x00,0x00,0x0c,0x01,0x00,0x43,0x02,0xff,0xff,0xff,0x3f,0x03);
		
		$actionTag = pack ("C*",0x88);
		$actionTag .= pack ("v",$pushLength);
		$actionTag .= pack ("C*",0x05,0x00);
		$actionTag.= $this->objectName;
		$actionTag .= pack ("C*",0x00);
		$actionTag.= "XML";
		$actionTag .= pack ("C*",0x00);
		$actionTag.= "ignoreWhite";
		$actionTag .= pack ("C*",0x00);
		$actionTag.= $this->xml;
		$actionTag .= pack ("C*",0x00);
		$actionTag.= "parseXML";
		$actionTag .= pack ("C*",0x00);
		$actionTag .= pack ("C*",0x96,0x0d ,0x00 ,0x08 ,0x00 ,0x06 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00,0x00 ,0x00 ,0x00 ,0x08 ,0x01 ,0x40 ,0x1d ,0x96 ,0x02 ,0x00 ,0x08 ,0x00 ,0x1c ,0x96 ,0x04 ,0x00,0x08 ,0x02 ,0x05);
		$actionTag .= pack ("C*",( $this->ignoreWhite ? 0x01 : 0x00) );
		$actionTag .= pack ("C*",0x4f ,0x96 ,0x09 ,0x00 ,0x08 ,0x03 ,0x07 ,0x01 ,0x00 ,0x00 ,0x00 ,0x08,0x00 ,0x1c ,0x96 ,0x02 ,0x00 ,0x08 ,0x04 ,0x52 ,0x17 ,0x00);
		$tagSize=pack ("V",strlen($actionTag));
		$endTags=pack ("C*",0x40,0x00,0x00,0x00);
		$filesize=pack ("V",strlen($basics)+strlen($actionTag)+strlen($endTags)+12);
		if ($this->compressed)
		$this->swf=$header.$filesize.gzcompress($basics.$tagSize.$actionTag.$endTags);
		else
		$this->swf=$header.$filesize.$basics.$tagSize.$actionTag.$endTags;
		
		$this->status="swf";
		$this->error="";
		return true;
		
	}
	// getSWF
	// 
	// if the internal swf object exists
	// this will return the swf data
	// otherwise it returns false
	function getSWF(){
		if ($this->status!="swf"){
			$this->error="No SWF data";
			return false;
		}
		return $this->swf;
	}
	
	// saveSWF
	// 
	// if the internal swf object exists
	// this will save a swf under the filename $swfname
	// 
	// if there is no swf data or the file could not be
	// written it returns false
	function saveSWF($swfname){
		if ($this->status!="swf"){
			$this->error="No SWF data";
			return false;
		}
		if ($swfname==""){
			$this->error="No Filename";
			return false;
		}
		if ($fp=fopen($swfname,"wb")){
			if (!$result=fwrite($fp,$this->swf)){
				$this->error="Could not write to $swfname";
				fclose($fp);
				return false;
			}
			fclose($fp);
		} else {
			$this->error="Could not open $swfname";
			return false;
		}
		$this->error="";
		return $result;
	}
}

